;;;; type-errors-numbers.impl.scm  -*- Scheme -*-
;;;; Kon Lovett, Jul '18

;;

(define-error-type number)
(define-error-type positive-number)
(define-error-type natural-number)
(define-error-type negative-number)
(define-error-type non-positive-number)
(define-error-type integer)
(define-error-type positive-integer)
(define-error-type natural-integer)
(define-error-type negative-integer)
(define-error-type non-positive-integer)
(define-error-type real)
(define-error-type complex)
(define-error-type rational)
(define-error-type exact)
(define-error-type inexact)

(define-error-type fixnum)
(define-error-type positive-fixnum)
(define-error-type natural-fixnum)
(define-error-type negative-fixnum)
(define-error-type non-positive-fixnum)

(define-error-type bignum)
(define-error-type positive-bignum)
(define-error-type negative-bignum)
(define-error-type non-positive-bignum)

(define-error-type ratnum)
(define-error-type positive-ratnum)
(define-error-type negative-ratnum)
(define-error-type non-positive-ratnum)

(define-error-type flonum)
(define-error-type float)

(define-error-type cplxnum)

;;

(define (error-range loc start end #!optional argnam)
  (signal-bounds-error loc (make-bad-argument-message argnam) start end) )

(define (error-interval loc num lft min max rgt #!optional argnam)
  (signal-bounds-error loc (make-error-interval-message lft min max rgt argnam) num) )

(define (error-closed-interval loc num min max #!optional argnam)
  (error-interval loc num #\[ min max #\] argnam) )

(define (error-open-interval loc num min max #!optional argnam)
  (error-interval loc num #\( min max #\) argnam) )

(define (error-half-open-interval loc num min max #!optional argnam)
  (error-interval loc num #\( min max #\] argnam) )

(define (error-half-closed-interval loc num min max #!optional argnam)
  (error-interval loc num #\[ min max #\) argnam) )
